Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## net.sf.saxon.tree.iter
Class NodeWrappingAxisIterator<T extends NodeInfo,B>

    java.lang.Object
      net.sf.saxon.tree.iter.NodeWrappingAxisIterator<T,B>

All Implemented Interfaces:
  SequenceIterator<T>, AxisIterator<T>, LookaheadIterator<T>, UnfailingIterator<T>

    public abstract class NodeWrappingAxisIterator<T extends NodeInfo,B>

extends Object
implements AxisIterator<T>, LookaheadIterator<T>, UnfailingIterator<T>

An AxisIterator that wraps a Java Iterator. This is an abstract class, because the Java iterator does not hold enough information to support the getAnother() method, needed to implement the XPath last() function

Field Summary

Fields inherited from interface net.sf.saxon.om.SequenceIterator
`GROUNDED, LAST_POSITION_FINDER, LOOKAHEAD`

Constructor Summary
`NodeWrappingAxisIterator(Iterator<B> base, NodeWrappingFunction<B,T> wrappingFunction)` Create a SequenceIterator over a given iterator

Method Summary
`Value` | `atomize()` Return the atomized value of the current node.
`void` | `close()` Close the iterator.
`T` | `current()` Get the current item in the sequence.
`abstract AxisIterator<T>` | `getAnother()` Get another iterator over the same sequence of items, positioned at the start of the sequence.
`int` | `getProperties()` Get properties of this iterator, as a bit-significant integer.
`CharSequence` | `getStringValue()` Return the string value of the current node.
`boolean` | `hasNext()` Determine whether there are more items to come.
`AxisIterator` | `iterateAxis(byte axis, NodeTest test)` Return an iterator over an axis, starting at the current node.
`boolean` | `moveNext()` Move to the next node, without returning it.
`T` | `next()` Get the next item in the sequence.
`int` | `position()` Get the current position

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### NodeWrappingAxisIterator

    public NodeWrappingAxisIterator(Iterator<B> base,
                                    NodeWrappingFunction<B,T> wrappingFunction)

  Create a SequenceIterator over a given iterator

  Parameters:
    `base` - the base Iterator
    `wrappingFunction` - a function that wraps objects of type B in a Saxon NodeInfo

Method Detail

### moveNext

    public boolean moveNext()

  Description copied from interface: `AxisIterator`
  Move to the next node, without returning it. Returns true if there is a next node, false if the end of the sequence has been reached. After calling this method, the current node may be retrieved using the current() function.

  Specified by:
    `moveNext` in interface `AxisIterator<T extends NodeInfo>`
  Returns:
    true if there is a next node, false if the end of the sequence has been reached

### iterateAxis

    public AxisIterator iterateAxis(byte axis,
                                    NodeTest test)

  Description copied from interface: `AxisIterator`
  Return an iterator over an axis, starting at the current node.

  Specified by:
    `iterateAxis` in interface `AxisIterator<T extends NodeInfo>`
  Parameters:
    `axis` - the axis to iterate over, using a constant such as `Axis.CHILD`
    `test` - a predicate to apply to the nodes before returning them.
  Returns:
    an iterator over an axis, starting at the current node

### atomize

    public Value atomize()
                  throws XPathException

  Description copied from interface: `AxisIterator`
  Return the atomized value of the current node.

  Specified by:
    `atomize` in interface `AxisIterator<T extends NodeInfo>`
  Returns:
    the atomized value.
  Throws:
    `XPathException` - if the current node cannot be atomized, for example because it is an element node with element-only content.

### getStringValue

    public CharSequence getStringValue()

  Description copied from interface: `AxisIterator`
  Return the string value of the current node.

  Specified by:
    `getStringValue` in interface `AxisIterator<T extends NodeInfo>`
  Returns:
    the string value, as an instance of CharSequence.

### hasNext

    public boolean hasNext()

  Description copied from interface: `LookaheadIterator`
  Determine whether there are more items to come. Note that this operation is stateless and it is not necessary (or usual) to call it before calling next(). It is used only when there is an explicit need to tell if we are at the last element.

  This method must not be called unless the result of getProperties() on the iterator includes the bit setting `SequenceIterator.LOOKAHEAD`

  Specified by:
    `hasNext` in interface `LookaheadIterator<T extends NodeInfo>`
  Returns:
    true if there are more items in the sequence

### next

    public T next()

  Description copied from interface: `UnfailingIterator`
  Get the next item in the sequence.

  Specified by:
    `next` in interface `SequenceIterator<T extends NodeInfo>`
  Specified by:
    `next` in interface `AxisIterator<T extends NodeInfo>`
  Specified by:
    `next` in interface `UnfailingIterator<T extends NodeInfo>`
  Returns:
    the next Item. If there are no more nodes, return null.

### current

    public T current()

  Description copied from interface: `UnfailingIterator`
  Get the current item in the sequence.

  Specified by:
    `current` in interface `SequenceIterator<T extends NodeInfo>`
  Specified by:
    `current` in interface `AxisIterator<T extends NodeInfo>`
  Specified by:
    `current` in interface `UnfailingIterator<T extends NodeInfo>`
  Returns:
    the current item, that is, the item most recently returned by next()

### position

    public int position()

  Description copied from interface: `UnfailingIterator`
  Get the current position

  Specified by:
    `position` in interface `SequenceIterator<T extends NodeInfo>`
  Specified by:
    `position` in interface `UnfailingIterator<T extends NodeInfo>`
  Returns:
    the position of the current item (the item most recently returned by next()), starting at 1 for the first node

### close

    public void close()

  Description copied from interface: `SequenceIterator`
  Close the iterator. This indicates to the supplier of the data that the client does not require any more items to be delivered by the iterator. This may enable the supplier to release resources. After calling close(), no further calls on the iterator should be made; if further calls are made, the effect of such calls is undefined.

  (Currently, closing an iterator is important only when the data is being "pushed" in another thread. Closing the iterator terminates that thread and means that it needs to do no additional work. Indeed, failing to close the iterator may cause the push thread to hang waiting for the buffer to be emptied.)

  Specified by:
    `close` in interface `SequenceIterator<T extends NodeInfo>`

### getAnother

    public abstract AxisIterator<T> getAnother()

  Description copied from interface: `UnfailingIterator`
  Get another iterator over the same sequence of items, positioned at the start of the sequence. It must be possible to call this method at any time, whether none, some, or all of the items in the original iterator have been read. The method is non-destructive: it does not change the state of the original iterator.

  Specified by:
    `getAnother` in interface `SequenceIterator<T extends NodeInfo>`
  Specified by:
    `getAnother` in interface `AxisIterator<T extends NodeInfo>`
  Specified by:
    `getAnother` in interface `UnfailingIterator<T extends NodeInfo>`
  Returns:
    a new iterator over the same sequence

### getProperties

    public int getProperties()

  Get properties of this iterator, as a bit-significant integer.

  Specified by:
    `getProperties` in interface `SequenceIterator<T extends NodeInfo>`
  Returns:
    the properties of this iterator. This will be some combination of properties such as `SequenceIterator.GROUNDED`, `SequenceIterator.LAST_POSITION_FINDER`, and `SequenceIterator.LOOKAHEAD`. It is always acceptable to return the value zero, indicating that there are no known special properties. It is acceptable for the properties of the iterator to change depending on its state.

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright (c) 2004-2011 Saxonica Limited. All rights reserved.